<template>
  <q-toolbar class="text-white text-h6">
    <div class="row items-center justify-center text-center full-width q-py-sm">
      <div :class="[hasCapacity ? 'primaryColor' : 'full', 'callstats']">
        <q-icon name="people" size="sm" class="statIcon"/>
        <span>{{ participantCount }} / {{ maxCapacity }}</span>
      </div>


      <div class="top-controls">
        <div class="btn-wrapper stay-right">
          <q-btn
            color="white bg-red"
            @click="requestEndCall"
            icon="call_end"
            round />
        </div>
        <div class="btn-wrapper">
          <q-btn
            color="white bg-blue"
            @click="requestAddPoll"
            icon="poll"
            round />
        </div> 
        <div class="btn-wrapper">
          <q-btn
            color="white bg-green"
            @click="requestAddParticipant"
            icon="person_add"
            round 
            :disable="!hasCapacity"/>
        </div>

      </div>

    </div>
  </q-toolbar>
</template>
<script>
import { DateTime } from "luxon";
import { functions } from "../firebase";

export default {
  props: {
    conferenceStart: {
      required: true,
    },
    conferenceParticipants: {
      required: true,
    },
    maxCapacity: {
      required: true,
    },
    hasCapacity: {
      required: true,
    }
  },
  data() {
    return {
      now: DateTime.now(),
      timer: undefined,
    };
  },
  computed: {
    duration() {
      if (this.conferenceStart == undefined) return "";
      const duration = this.now.diff(DateTime.fromMillis(this.conferenceStart));
      const seconds = duration / 1000;
      const minutes = seconds / 60;
      const hours = minutes / 60;
      return this.$t("active_conference_toolbar.duration", {
        hours: Math.floor(hours),
        minutes: Math.floor(minutes % 60),
        seconds: Math.round(seconds % 60),
      });
    },
    participantCount() {
      if (this.conferenceParticipants == undefined) return;
      const activeParticipants = {};
      for (const phoneNumber in this.conferenceParticipants) {
        if (this.conferenceParticipants[phoneNumber].Status === "Active")
          activeParticipants[phoneNumber] = {
            ...this.conferenceParticipants[phoneNumber],
          };
      }
      return Object.keys(activeParticipants).length;
    },
  },
  methods: {
    requestAddParticipant() {
      this.$emit("addparticipant");
    },
    requestAddPoll() {
      this.$emit("addPoll");
    },
    requestEndCall() {
      this.$emit("endcall");
    },
    handleMuteAll() {
      const fbFunction = functions.httpsCallable("muteUnmuteConference");
      fbFunction({
        ConferenceId: this.$route.params.id,
        Mute: true,
      });
    },
    handleUnmuteAll() {
      const fbFunction = functions.httpsCallable("muteUnmuteConference");
      fbFunction({
        ConferenceId: this.$route.params.id,
        Mute: false,
      });
    },
  },
  created() {
    var self = this;
    this.timer = setInterval(function () {
      self.now = DateTime.now();
    }, 10 * 100); // Rerender every second
  },
  beforeDestroy() {
    clearTimeout(this.timer);
  },
};
</script>
<style scoped>
  .primaryColor {
    color: var(--q-color-primary);
  }

  .full {
    color: red;
  }

  @media only screen and (min-width: 200px) {
    .top-controls {
      width: 100%;
      display: inline-block;
      margin: 10px 15px 0px 15px;
    }
    .top-controls .btn-wrapper {
      width: 33.3%;
      float:right;
      display: inline;
      margin: 0px auto 0px auto;
    }
    .callstats {
      width: 100%;
      display: inline-block;
      font-size: 18px;
      text-align: center;
      padding-bottom: 5px;
    }
    .callstats .statIcon {
      text-align: center;
      padding-right: 6px;
    }
    .callstats span {
      display: inline-block;
      padding-right: 8px;
    }
  }
  
  @media only screen and (min-width: 350px) {
    .top-controls {
      width: 70%;
    }
    .callstats {
      font-size: 20px;
    }
    .callstats span {
      padding-right: 15px;
    }
  }

  @media only screen and (min-width: 500px) {
    .top-controls {
      width: 40%;
      float:right;
      margin: 10px 0px;
      display: inline;
    }
    .callstats {
      width: 40%;
      float:left;
      text-align: left;
      margin: 10px 0px 10px 10px;
      display: inline;
    }
    .top-controls .btn-wrapper {
      width: 20%;
      margin: 0px 5px 0px 5px;
    }
  }


</style>